#ifndef ROOM_H
#define ROOM_H

#include <string>

///////////////////////////////////////////////////////////////////////////////
// room
///////////////////////////////////////////////////////////////////////////////

struct room
{
   std::string code;    // room code, e.g., "DK1"
   std::string name;    // room name, e.g., "Dewan Kuliah 1"
   int owner;           // owner of the room (faculty code; code 0 means belongs to all)
   int size;            // number of people the room can accommodate
   bool bLab;           // true if the room is a lab

   room();
   room(room const &rhs);

   room &operator=(room const &rhs);
   bool operator==(room const &rhs) const;
   bool operator<(room const &rhs) const;
};


///////////////////////////////////////////////////////////////////////////////
// room definitions
///////////////////////////////////////////////////////////////////////////////

inline room::room()
   : owner(0), size(0), bLab(false)
{}

inline room::room(room const &rhs)
   : code(rhs.code), name(rhs.name), owner(rhs.owner), size(rhs.size), bLab(rhs.bLab)
{}

inline room &room::operator=(room const &rhs)
{
   code = rhs.code;
   name = rhs.name;
   owner = rhs.owner;
   size = rhs.size;
   bLab = rhs.bLab;
   return *this;
}

inline bool room::operator==(room const &rhs) const
{
   return (code == rhs.code);
}

inline bool room::operator<(room const &rhs) const
{
   return (code < rhs.code);
}

#endif
